/* -*- mode: c; c-basic-offset: 2; -*- */
/******** <lalVerbatim file="ExtTrigApplySearchHV"> ********
Author: Rahkola, R
$Id: ExtTrigApplySearch.h,v 1.4 2003/01/30 18:29:55 rrahkola Exp $
********* </lalVerbatim> ********/

#ifndef _EXTTRIGAPPLYSEARCH_H
#define _EXTTRIGAPPLYSEARCH_H

#include <lal/LALRCSID.h>
#include <LALWrapperInterface.h>

#ifdef __cplusplus
extern "C" {
#endif

NRCSID( EXTTRIGAPPLYSEARCH, "$Id: ExtTrigApplySearch.h,v 1.4 2003/01/30 18:29:55 rrahkola Exp $");

/************** <lalErrTable file="ExtTrigApplySearchHErrTab"> */
#define APPLYSEARCHH_ENULL 1
#define APPLYSEARCHH_ENNUL 2
#define APPLYSEARCHH_ERANK 3
#define APPLYSEARCHH_ESEND 4
#define APPLYSEARCHH_EALOC 6
#define APPLYSEARCHH_ENUMZ 7
#define APPLYSEARCHH_EDELT 8
#define APPLYSEARCHH_ELGTH 9
#define APPLYSEARCHH_EUEXT 10
#define APPLYSEARCHH_EDUMY 50

#define APPLYSEARCHH_MSGENULL "exttrig:Null pointer"
#define APPLYSEARCHH_MSGENNUL "exttrig:Non-null pointer"
#define APPLYSEARCHH_MSGESEND "exttrig:Invalid MPI Message"
#define APPLYSEARCHH_MSGEALOC "exttrig:Memory allocation error"
#define APPLYSEARCHH_MSGENUMZ "exttrig:Data segment length is zero"
#define APPLYSEARCHH_MSGEDELT "exttrig:deltaT is zero or negative"
#define APPLYSEARCHH_MSGELGTH "exttrig:Different lengths for timeseries"
#define APPLYSEARCHH_MSGERANK "exttrig:Search node has incorrect rank"
#define APPLYSEARCHH_MSGEUEXT "exttrig:Unrecognised exchange type"
#define APPLYSEARCHH_MSGEDUMY "exttrig:Completed dummy routine"

/************************************ </lalErrTable> */

void
ExtTrigBuildDB(
	       LALStatus             *const status,
	       LALSearchOutput       *const output,
	       const ETSearchParams  *const params );


void
ExtTrigBuildILWD(
		 LALStatus             *const status,
		 LALSearchOutput       *const output,
		 const ETSearchParams  *const params );


#ifdef __cplusplus
}
#endif

#endif /* _EXTTRIGAPPLYSEARCH_H */
