/******** <lalVerbatim file="FCTFinalizeSearchCV"> ******** 
Author: Wen, L. 
$Id: FCTFinalizeSearch.c,v 1.1 2001/12/13 00:32:28 teviet Exp $ 
********* </lalVerbatim> ********/ 

#include <FCTGeneral.h>
#include <FCTFinalizeSearch.h> 
#include <FCTHierSupport.h>

NRCSID( FCTFINALIZESEARCHC, "$Id: FCTFinalizeSearch.c,v 1.1 2001/12/13 00:32:28 teviet Exp $");

void 
LALFinalizeSearch( 
		  LALStatus *status, 
		  void **searchParams ) 
{

  FCTSearchParams   *mySearchParams;
  INT4 j; 

  INITSTATUS( status, "LALFinalizeSearch", FCTFINALIZESEARCHC ); 
  ATTATCHSTATUSPTR (status);

#ifdef FCT_SO_DEBUG  
  
  /*    lalDebugLevel=24;  */
  printf("in FinalizeSearch()\n");
#endif


  mySearchParams=(FCTSearchParams *) *searchParams;
  

  /* from ApplySearch */
  LALFree(mySearchParams->numProcs);

  /*FCT PLAN stuff (from ChangeFCTPlan) */
  if (mySearchParams->fctInParams->fctInput) {
    LALCDestroyVector(status->statusPtr, &(mySearchParams->fctInParams->fctInput));
    CHECKSTATUSPTR (status);
  }
  
  if (mySearchParams->fctInParams->fctPlan) {
    LALDestroyFCTPlan(status->statusPtr, &(mySearchParams->fctInParams->fctPlan));
    CHECKSTATUSPTR (status);
  }
  

  for( j = 0; j < mySearchParams->numHierLevels; j++){
    /*destroy the event lists */
    destroyEventList(mySearchParams->hierLevelEvents[j]);
    mySearchParams->numHierLevelEvents[j] = 0;

    /* From InitSearch */
    LALFree(mySearchParams->hierLevelUnits[j].range);
    LALFree(mySearchParams->hierLevelUnits[j].physicalStepSize);
    LALFree(mySearchParams->hierLevelUnits[j].indexRange);
    LALFree(mySearchParams->hierLevelUnits[j].fctUnits); 
    LALFree(mySearchParams->hierLevelUnits[j].stride);
  }
  destroyEventList(mySearchParams->hierLevelEvents[mySearchParams->numHierLevels]);
  mySearchParams->numHierLevelEvents[mySearchParams->numHierLevels] = 0;

  /*from InitSearch */
  LALFree(mySearchParams->hierLevelUnits); 
  LALFree(mySearchParams->hierLevelEvents); 
  LALFree(mySearchParams->numHierLevelEvents); 
  LALFree(mySearchParams->lowestEvent);
  LALFree(mySearchParams->powerThreshold);

  LALFree(mySearchParams->fctInParams->cube);
  /* added, -Linqing */
  LALFree(mySearchParams->fctInParams->freqMoment);
  LALFree(mySearchParams->fctInParams);
  LALFree(mySearchParams);
  
  *searchParams = NULL;  

#ifdef FCT_SO_DEBUG
  
  printf("out of FinalizeSearch()\n");
#endif

  DETATCHSTATUSPTR (status);
  RETURN( status ); 
}


