
#ifndef _CASTTOFUNCTIONS_H
#define _CASTTOFUNCTIONS_H

#include <lal/LALDatatypes.h>
#include <lal/LALStdlib.h>
#include <lal/LALConstants.h>
#include <lal/AVFactories.h>
#include <lal/DetectorSite.h>
#include <lal/Units.h>
#include <lal/Window.h>
#include <lal/Calibration.h>
#include <ExtractSeries.h>
#include "SGWB.h"
#include "SGWBConditionData.h"

#ifdef  __cplusplus   /* C++ protection. */
extern "C" {
#endif

  /* static */  /* inline */ 
INT4 ctoi (CHAR c);

  /* static  */
void CastToReal4 ( LALStatus *status, REAL4 *output,
			  const multiDimData *input,
			  const UINT4 offset, const UINT4 length );

  /* static  */
void CastToComplex8 ( LALStatus *status, COMPLEX8 *output,
			     const multiDimData *input,
			     const UINT4 offset, const UINT4 length );


#ifdef  __cplusplus
}
#endif /* C++ protection. */

#endif /* _CASTTOFUNCTIONS_H  */
