#ifndef _SGWBAUXFUNCTIONS_H
#define _SGWBAUXFUNCTIONS_H

#include <lal/LALStdlib.h>
#include <lal/LALDatatypes.h>
#include <lal/LALRCSID.h>
#include <lal/Window.h>

#ifdef  __cplusplus   /* C++ protection. */
extern "C" {
#endif

  NRCSID (SGWBAUXFUNCTIONSH, "$Id: SGWBAuxFunctions.h,v 1.3 2003/09/29 20:11:29 kaice Exp $");

  typedef struct
  tagSequenceIndices
  { 
    INT4 data1Index;
    INT4 data2Index;
    INT4 resp1Index;
    INT4 resp2Index;
    INT4 spec1Index;
    INT4 spec2Index;
  }
  SequenceIndices;

  void LALFindCheckMDSequences( LALStatus *status,
				LALSearchInput *input,
				StochasticSearchParams *params,
				SequenceIndices *sI);

  void LALAllocateParamFieldMemory( LALStatus *status,
				    StochasticSearchParams *params,
				    COMPLEX8FrequencySeries **resp1,
				    COMPLEX8FrequencySeries **resp2,
				    REAL4FrequencySeries **spec1,
				    REAL4FrequencySeries **spec2,
				    REAL4FrequencySeries **spec1Ptr,
				    REAL4FrequencySeries **spec2Ptr);

  void LALCalculateSpec1Spec2( LALStatus *status,
			       StochasticSearchParams *params,
			       REAL4FrequencySeries **spec1,
			       REAL4FrequencySeries **spec2,
			       REAL4FrequencySeries **spec1Ptr,
			       REAL4FrequencySeries **spec2Ptr,
			       FrequencySamplingParams freqParams);

  void LALCalculateResp1Resp2( LALStatus *status,
			       LALSearchInput *input,
			       StochasticSearchParams *params,
			       COMPLEX8FrequencySeries **resp1, 
			       COMPLEX8FrequencySeries **resp2,
			       FrequencySamplingParams freqParams,
			       SequenceIndices sI);

  void LALSGWBCoreApplySearch ( LALStatus *status,
				LALSearchOutput *output,
				LALSearchInput *input,
				StochasticSearchParams *params);

  void LALAssignDataPointers( LALStatus *status,
			      LALSearchInput *inout,
			      StochasticSearchParams *params,
			      SequenceIndices sI);


#ifdef  __cplusplus
}
#endif /* C++ protection. */

#endif /* _STOCHASTICDATA_H  */
