/*----------------------------------------------------------------------- 
 * 
 * File Name: FinalizeSearch.c
 *
 * Author: Brown, D. A.
 * 
 * Revision: $Id: FinalizeSearch.c,v 1.1 2001/06/04 04:39:47 duncan Exp $
 * 
 *-----------------------------------------------------------------------
 */

#include "FinalizeSearch.h"

NRCSID( FINALIZESEARCHC, PKG "$Id: FinalizeSearch.c,v 1.1 2001/06/04 04:39:47 duncan Exp $" );

void
LALFinalizeSearch(
    LALStatus             *status,
    void                 **searchParams
                 )
{
  SimpleSearchParams *params;

  INITSTATUS( status, "LALFinalizeSearch", FINALIZESEARCHC );
  ATTATCHSTATUSPTR( status );


  /* check and cast parameter structure */
  ASSERT( *searchParams, status,
      FINALIZESEARCH_ENULL, FINALIZESEARCH_MSGENULL );

  params = (SimpleSearchParams *) *searchParams;


  /*
   *
   * free the memory used in the search
   *
   */


  /* free the vector that held the conditioned data */
  LALDestroyVector( status->statusPtr, &(params->dataVec) );
  CHECKSTATUSPTR( status );

  /* free the search parameter structure */
  LALFree( *searchParams );
  *searchParams = NULL;


  /* normal exit */
  DETATCHSTATUSPTR( status );
  RETURN( status );
}
