/**** <lalVerbatim file="TrackSearchInitHV"> ***********
Author: Torres, C
$Id: TrackSearchInit.h,v 1.2 2003/10/08 19:48:24 jolien Exp $ 
***** </lalVerbatim> ***********************************/

#ifndef _TRACKSEARCHINIT_H
#define _TRACKSEARCHINIT_H

/* #include <lal/LALStdlib.h> */
#include <lal/TSSearch.h>
#include "Power.h"

#ifdef  __cplusplus
extern "C" {
#endif

NRCSID (TRACKSEARCHINITH, "$Id: TrackSearchInit.h,v 1.2 2003/10/08 19:48:24 jolien Exp $");

/******** <lalErrTable file="PowerInitSearchHErrTab"> ********/
#define TRACKSEARCHINITH_ENULL     1
#define TRACKSEARCHINITH_ENNUL     2
#define TRACKSEARCHINITH_EALOC     3
#define TRACKSEARCHINITH_EARGS     4
#define TRACKSEARCHINITH_ENUMZ     5
#define TRACKSEARCHINITH_ESEGZ     6
#define TRACKSEARCHINITH_EOVLP     7
#define TRACKSEARCHINITH_EOVPF     8
#define TRACKSEARCHINITH_EMFBZ     9
#define TRACKSEARCHINITH_EMTBZ     10
#define TRACKSEARCHINITH_EFLOW     11
#define TRACKSEARCHINITH_EDELF     12
#define TRACKSEARCHINITH_ELTFZ     13
#define TRACKSEARCHINITH_ESIGM     14
#define TRACKSEARCHINITH_EALPH     15
#define TRACKSEARCHINITH_EFREE     16
#define TRACKSEARCHINITH_ENLAL     17
#define TRACKSEARCHINITH_ENDAT     18
#define TRACKSEARCHINITH_EDUTY     19
#define TRACKSEARCHINITH_EAMAX     20 
#define TRACKSEARCHINITH_EE2MS     21 
#define TRACKSEARCHINITH_ECHNL     22 
#define TRACKSEARCHINITH_ESIM      23


#define TRACKSEARCHINITH_MSGENULL     "Null pointer"
#define TRACKSEARCHINITH_MSGENNUL     "Non-null pointer"
#define TRACKSEARCHINITH_MSGEALOC     "Memory allocation error"
#define TRACKSEARCHINITH_MSGEARGS     "Wrong number of arguments"
#define TRACKSEARCHINITH_MSGENUMZ     "Data segment length is zero or negative"
#define TRACKSEARCHINITH_MSGESEGZ     "Number of data segments is zero or negative"
#define TRACKSEARCHINITH_MSGEOVLP     "Overlap of data segments is negative"
#define TRACKSEARCHINITH_MSGEOVPF     "Overlap of TF tiles is negative"
#define TRACKSEARCHINITH_MSGEMFBZ     "Smallest extent in freq of TF tile is zero" 
#define TRACKSEARCHINITH_MSGEMTBZ     "Smallest extent in time of TF tile is zero"
#define TRACKSEARCHINITH_MSGEFLOW     "Lowest frequency to be searched is <= 0"
#define TRACKSEARCHINITH_MSGEDELF     "Freq resolution of 1st time-freq plane is <=0"
#define TRACKSEARCHINITH_MSGELTFZ     "Length (Nf) of 1st TF plane (with Nt=1) is <=0"
#define TRACKSEARCHINITH_MSGESIGM     "Threshold number of sigma is <=1"
#define TRACKSEARCHINITH_MSGEALPH     "Default alpha value is out of range"
#define TRACKSEARCHINITH_MSGEFREE     "Memory free error"
#define TRACKSEARCHINITH_MSGENLAL     "Tried to allocate to non-null pointer"
#define TRACKSEARCHINITH_MSGENDAT     "No data read"
#define TRACKSEARCHINITH_MSGEDUTY     "Number of segments sent to slave is zero"
#define TRACKSEARCHINITH_MSGEAMAX     "The threshold value of alpha is negative"
#define TRACKSEARCHINITH_MSGEE2MS     "Number of events out of range[1..99]"
#define TRACKSEARCHINITH_MSGECHNL     "Channel name not valid"
#define TRACKSEARCHINITH_MSGESIM      "Invalid simulation type: 0, 1, or 2"
/******** </lalErrTable> ********/

/*
 *
 * libpower.so should be invoked with the following arguments to wrapperAPI
 *
 * argv[0]  = "-filterparams"
 * argv[1]  = numPoints         Number of data points in a segment (2 * 2^p + 2)
 * argv[2]  = numSegments       Number of overlapping segments
 * argv[3]  = ovrlap            Number of points overlap between segments
 * argv[4]  = overlapFactor     Amount of overlap between neighboring TF tiles
 * argv[5]  = minFreqBins       Smallest extent in freq of TF tiles to search
 * argv[6]  = minTimeBins       Smallest extent in time of TF tiles to search
 * argv[7]  = flow              Lowest frequency in Hz to be searched
 * argv[8]  = deltaF            Frequency resolution of first TF plane
 * argv[9]  = length            Length (N_F) of first TF plane (with N_T = 1)
 * argv[10] = numSigmaMin       threshold number of sigma
 * argv[11] = alphaDefault      default alpha value for tiles with sigma < numSigmaMin
 * argv[12] = segDutyCycle      Number of segments sent to slave for analysis
 * argv[13] = alphaThreshold    Indentify events with alpha less than this
 * argv[14] = events2Master     Number of events out or range[1..99]
 * argv[15] = channelName       Channel name
 */

#ifdef  __cplusplus
}
#endif

#endif /* _TRACKSEARCHINIT_H  */

