/**** <lalVerbatim file="TrackSearchInitHV"> ***********
Author: Torres, C
$Id: TrackSearchInitSearch.h,v 1.2 2003/10/08 19:48:24 jolien Exp $ 
***** </lalVerbatim> ***********************************/

#ifndef _TRACKSEARCHINITSEARCH_H
#define _TRACKSEARCHINITSEARCH_H

#include <lal/LALStdlib.h>
#include "TrackSearch.h"
#include <lal/LALDatatypes.h>
#include <lal/TSSearch.h>
#include <lal/LALRCSID.h>

#ifdef  __cplusplus
extern "C" {
#endif

NRCSID (TRACKSEARCHINITSEARCHH, "$Id: TrackSearchInitSearch.h,v 1.2 2003/10/08 19:48:24 jolien Exp $");

/******** <lalErrTable file="TrackSearchInitSearchHErrTab"> ********/
#define TRACKSEARCHINITSEARCHH_ENULL     1
#define TRACKSEARCHINITSEARCHH_ENNUL     2
#define TRACKSEARCHINITSEARCHH_EALOC     3
#define TRACKSEARCHINITSEARCHH_EARGS     4
#define TRACKSEARCHINITSEARCHH_EZARG     5
#define TRACKSEARCHINITSEARCHH_EGPST     6
#define TRACKSEARCHINITSEARCHH_ENUMZ     7
#define TRACKSEARCHINITSEARCHH_ESEGZ     8
#define TRACKSEARCHINITSEARCHH_EWIND     9
#define TRACKSEARCHINITSEARCHH_EWIDE     10
#define TRACKSEARCHINITSEARCHH_ECSPT     11
#define TRACKSEARCHINITSEARCHH_ECLPT     12
#define TRACKSEARCHINITSEARCHH_ELINE     13
#define TRACKSEARCHINITSEARCHH_EPOWL     14
#define TRACKSEARCHINITSEARCHH_EFREE     15
#define TRACKSEARCHINITSEARCHH_ENLAL     16
#define TRACKSEARCHINITSEARCHH_ENDAT     17
#define TRACKSEARCHINITSEARCHH_EDUTY     18
#define TRACKSEARCHINITSEARCHH_EAMAX     19 
#define TRACKSEARCHINITSEARCHH_EE2MS     20 
#define TRACKSEARCHINITSEARCHH_ECHNL     21 

#define TRACKSEARCHINITSEARCHH_MSGENULL     "Null pointer"
#define TRACKSEARCHINITSEARCHH_MSGENNUL     "Non-null pointer"
#define TRACKSEARCHINITSEARCHH_MSGEALOC     "Memory allocation error"
#define TRACKSEARCHINITSEARCHH_MSGEARGS     "Wrong number of arguments"
#define TRACKSEARCHINITSEARCHH_MSGEZARG     "Parameter filter argument errors"
#define TRACKSEARCHINITSEARCHH_MSGEGPST     "Invalid GPS Starting Time"
#define TRACKSEARCHINITSEARCHH_MSGENUMZ     "Data segment length is zero or negative"
#define TRACKSEARCHINITSEARCHH_MSGESEGZ     "Number of data segments is zero or negative"
#define TRACKSEARCHINITSEARCHH_MSGEWIND     "Invalid Transformation Specified"
#define TRACKSEARCHINITSEARCHH_MSGEWIDE     "Invalid Curve Width Specified"
#define TRACKSEARCHINITSEARCHH_MSGECSPT     "Invalid Curve Start Point Threshold"
#define TRACKSEARCHINITSEARCHH_MSGECLPT     "Invalid Curve Line Point Threshold"
#define TRACKSEARCHINITSEARCHH_MSGELINE     "Specified Line Length Invalid"
#define TRACKSEARCHINITSEARCHH_MSGEPOWL     "Specified Line Power Invalid"
#define TRACKSEARCHINITSEARCHH_MSGEFREE     "Memory free error"
#define TRACKSEARCHINITSEARCHH_MSGENLAL     "Tried to allocate to non-null pointer"
#define TRACKSEARCHINITSEARCHH_MSGENDAT     "No data read"
#define TRACKSEARCHINITSEARCHH_MSGEDUTY     "Number of segments sent to slave is zero"
#define TRACKSEARCHINITSEARCHH_MSGEAMAX     "The threshold value of alpha is negative"
#define TRACKSEARCHINITSEARCHH_MSGEE2MS     "Number of events out of range[1..99]"
#define TRACKSEARCHINITSEARCHH_MSGECHNL     "Channel name not valid"

/******** </lalErrTable> ********/

/*
 *????????????????????MUST CUSTOMIZE THIS SECTION LATER?????????????????????
 * libpower.so should be invoked with the following arguments to wrapperAPI
 *
 * argv[0]  = "-filterparams"
 * argv[1]  = numPoints         Number of data points in a segment (2 * 2^p + 2)
 * argv[2]  = numSegments       Number of overlapping segments
 * argv[3]  = ovrlap            Number of points overlap between segments
 * argv[4]  = overlapFactor     Amount of overlap between neighboring TF tiles
 * argv[5]  = minFreqBins       Smallest extent in freq of TF tiles to search
 * argv[6]  = minTimeBins       Smallest extent in time of TF tiles to search
 * argv[7]  = flow              Lowest frequency in Hz to be searched
 * argv[8]  = deltaF            Frequency resolution of first TF plane
 * argv[9]  = length            Length (N_F) of first TF plane (with N_T = 1)
 * argv[10] = numSigmaMin       threshold number of sigma
 * argv[11] = alphaDefault      default alpha value for tiles with sigma < numSigmaMin
 * argv[12] = segDutyCycle      Number of segments sent to slave for analysis
 * argv[13] = alphaThreshold    Indentify events with alpha less than this
 * argv[14] = events2Master     Number of events out or range[1..99]
 * argv[15] = channelName       Channel name
 */

#define TRACKSEARCH_SO_ATTACH_DDD

#ifdef  __cplusplus
}
#endif

#endif /* _TRACKSEARCHINITSEARCH_H  */
