/********************************** <lalVerbatim file="TSFinalizeSearchCV">
Author: Charlie Torres
$Id: TrackSearchFinalizeSearch.c,v 1.1 2003/10/08 15:05:12 jolien Exp $
**************************************************** </lalVerbatim> */

#include <lal/LALDatatypes.h>
#include <lal/LALStdlib.h>
#include <lal/ExcessPower.h>
#include <lal/TFTransform.h>
#include <lal/TSData.h>
#include <lal/TSSearch.h>
#include "TrackSearchFinalizeSearch.h"

NRCSID( FINALIZESEARCHC, "tracksearch $Id: TrackSearchFinalizeSearch.c,v 1.1 2003/10/08 15:05:12 jolien Exp $");

void
LALFinalizeSearch(
		  LALStatus          *status,
		  void               **searchparams
		  )
{
  TSSearchParams   *params; 
  TSSegmentVector  *segToClean;

  INITSTATUS(status,"LALFinalizeSearch",FINALIZESEARCHC);
  ATTATCHSTATUSPTR (status);
  
  /* check searchParams exists and cast approriately */
  if ( !(*searchparams) ){
    ABORT( status, FINALIZESEARCHH_ENULL, FINALIZESEARCHH_MSGENULL );
  }
  params = (TSSearchParams *) *searchparams;

  /* destroy memory for conditioned segments */
  /* write following routine */
  segToClean = (params->dataSegVec);
  LALDestroyTSDataSegmentVector(status->statusPtr, &(segToClean));
  

  if ( params->searchMaster )
  {
    /* free numSlaves */
    LALFree (params->numSlaves);
  }
  
  /* Free channel name string */
  LALFree(params->channelName);

  /* free searchParams */
  LALFree (*searchparams);
  *searchparams = NULL;

  DETATCHSTATUSPTR (status);
  RETURN (status);
}


